<project name="build" default="build">
    <property name="conf" value="sync" />

    <target name="build">
        <echo>Building site</echo>

        <phingcall target="project:pre-build" />

        <!-- Update the autoload classes & install dependencies -->
        <phingcall target="install-composer-dependencies" />

        <!-- Initialization of the drupal console -->
        <phingcall target="init-drupal-console" />

        <if>
            <not>
                <isset property="env.TRAVIS" />
            </not>
            <then>
                <!-- Performing backup of existing environment -->
                <phingcall target="backup-all" />
            </then>
        </if>

        <!-- if import.db.file is defined, perform import -->
        <if>
            <and>
                <isset property="import.db.file" />
                <not>
                    <equals arg1="${import.db.file}" arg2="" />
                </not>
            </and>
            <then>
                <echo>Performing database import</echo>
                <drush
                    command="sql-drop"
                    assume="yes"
                    root="${website.drupal.dir}"
                    bin="${drush.bin}"
                    verbose="${drush.verbose}"
                    uri="${multisite.uri}"
                />
                <exec command="zcat ${import.db.file} | ${drush.bin} sqlc"
                      dir="${website.drupal.dir}/"
                      passthru="true" />
            </then>
            <else>
                <!-- Create drushrc.php -->
                <phingcall target="rewrite-drushrc" />

                <drush
                        command="site-install"
                        assume="yes"
                        root="${website.drupal.dir}"
                        bin="${drush.bin}"
                        verbose="${drush.verbose}"
                        uri="${multisite.uri}"
                >
                    <param>${website.profile.name}</param>
                    <param escape="no">install_configure_form.enable_update_status_module=NULL</param>
                    <option name="locale" value="${website.locale}"/>
                    <option name="site-name" value="${website.site.name}"/>
                </drush>

                <!-- clear cache -->
                <phingcall target="clear-cache" />

                <!-- Export config if there is no exported config (as in an install) -->
                <if>
                    <not>
                        <available file="${website.config.path}/sync/system.site.yml" type="file"/>
                    </not>
                    <then>
                        <!-- Performing backup of existing environment -->
                        <phingcall target="drush:cex" />
                    </then>
                </if>

                <echo>Synchronizing site and lang UUID into the current instance.</echo>
                <phingcall target="sync-site-uuid" />
                <phingcall target="sync-lang-uuid" />

                <!-- Removing default shortcut links, this is mandatory for the importation to be done. -->
                <!-- More details here: https://www.drupal.org/node/2583113 -->
                <!-- @todo: Remove this when the issue is fixed on drupal.org. -->
                <echo>
                    Removing default shortcut links to ensure a proper importation.
                    This is a community fix, see https://www.drupal.org/node/2583113).
                </echo>
                <exec command="${drupal.bin} entity:delete shortcut_set default --uri=${multisite.uri}" dir="${project.basedir}/web" passthru="true" />

                <phingcall target="project:pre-drupal-config-import" />
                <echo>Importing configuration from sync</echo>
                <echo>Importing configuration from sync 1/2</echo>
                <phingcall target="drush:cim" />
                <!-- done twice for config split -->
                <echo>Importing configuration from sync 2/2</echo>
                <phingcall target="drush:cim" />
                <phingcall target="project:post-drupal-config-import" />
            </else>
        </if>

        <phingcall target="project:post-build" />

    </target>
</project>